/**
 * DevExtreme (ui/rich_text_editor/converters/delta.js)
 * Version: 18.2.0 (build 18267)
 * Build date: Mon Sep 24 2018
 *
 * Copyright (c) 2012 - 2018 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = void 0;
var _createClass = function() {
    function defineProperties(target, props) {
        for (var i = 0; i < props.length; i++) {
            var descriptor = props[i];
            descriptor.enumerable = descriptor.enumerable || false;
            descriptor.configurable = true;
            if ("value" in descriptor) {
                descriptor.writable = true
            }
            Object.defineProperty(target, descriptor.key, descriptor)
        }
    }
    return function(Constructor, protoProps, staticProps) {
        if (protoProps) {
            defineProperties(Constructor.prototype, protoProps)
        }
        if (staticProps) {
            defineProperties(Constructor, staticProps)
        }
        return Constructor
    }
}();
var _quillDeltaToHtml = require("quill-delta-to-html");
var QuillDeltaConverter = _interopRequireWildcard(_quillDeltaToHtml);
var _ui = require("../../widget/ui.errors");
var _ui2 = _interopRequireDefault(_ui);
var _converterController = require("../converterController");
var _converterController2 = _interopRequireDefault(_converterController);

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        "default": obj
    }
}

function _interopRequireWildcard(obj) {
    if (obj && obj.__esModule) {
        return obj
    } else {
        var newObj = {};
        if (null != obj) {
            for (var key in obj) {
                if (Object.prototype.hasOwnProperty.call(obj, key)) {
                    newObj[key] = obj[key]
                }
            }
        }
        newObj.default = obj;
        return newObj
    }
}

function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function")
    }
}
var DeltaConverter = function() {
    function DeltaConverter() {
        _classCallCheck(this, DeltaConverter);
        var converter = QuillDeltaConverter && (QuillDeltaConverter.QuillDeltaToHtmlConverter || QuillDeltaConverter.default);
        if (!converter) {
            throw _ui2.default.Error("E1041", "QuillDeltaToHtmlConverter")
        }
        this._delta2Html = new converter
    }
    _createClass(DeltaConverter, [{
        key: "toHtml",
        value: function(deltaOps) {
            this._delta2Html.rawDeltaOps = deltaOps;
            return this._delta2Html.convert()
        }
    }]);
    return DeltaConverter
}();
_converterController2.default.addConverter("delta", DeltaConverter);
exports.default = DeltaConverter;
